; ***** ERROR HANDLER *****
(defun *ERROR* (msg)
	(princ "\nError : ")
	(princ msg)
	(princ)
)

(setvar "APBOX" 1)
(setvar "APERTURE" 5)
(setvar "PICKBOX" 3)
(setvar "BLIPMODE" 0)
(setvar "CMDDIA" 1)
(setvar "CMDECHO" 0)
(setvar "EXPERT" 1)
(setvar "MIRRTEXT" 0)
(setvar "SKPOLY" 1)
(setvar "DIMDEC" 3)
(setvar "DIMAUNIT" 1)
(setvar "DIMFIT" 4)
(setvar "DIMTAD" 0)
(setvar "DIMZIN" 0)
(setvar "FILEDIA" 1)
(setvar "PLINETYPE" 0)

(command "viewres" "y" "200")
(command "units" "2" "3" "2" "4" "0" "N")
(command "setvar" "coords" "2")

; ***** COMAS V1.8 *****
; comas agrega una coma a los miles y a los millones
; (comas 12345678.12345) -> "12,345,678.123"
(defun comas (num / numaux signo ent)
	(if (< num 0)
		(setq signo "-")
		(setq signo "")
	)

	(setq numaux (rtos (abs num) 2 3))

	(setq ent (substr numaux 1 (1- (pos "." numaux))))

	(if (> (strlen ent) 3)
		(setq ent (ins "," ent (- (strlen ent) 2)))
	)
	(if (> (strlen ent) 7)
		(setq ent (ins "," ent (- (strlen ent) 6)))
	)
	(strcat signo ent (substr numaux (pos "." numaux) 4))
)

; ***** COMASNZ V1.5 *****
; igual que la funcion comas pero no acepta ceros
(defun comasnz (num)
	(if (= num 0.0)
		(eval " ")
		(comas num)
	)
)

; ***** DDSETUP V1.5 *****
; Rutina que despliega un cuadro de dialogo para
; leer ciertas variables importantes
(defun c:ddsetup (/ defaults get_scale get_vt
				dcl_id next_event)
	(defun defaults ()
		(setq scale (getvar "USERI1"))
		(if (= scale 0)
			(setq scale 500)
		)

		(if (not vt)
			(progn
				(setq nodolist nil)
				(vt1 "1" 1 nil)
				(setq vt (1+ maxvt))
			)
		)
	)

	(defun get_scale ()
		(setq scale (atoi (get_tile "scale")))
	)

	(defun get_vt ()
		(setq vt (atoi (get_tile "vt")))
	)

	(setq dcl_id (load_dialog "Geotop.dcl"))
	(setq next_event 10) ;dummy value

	(while (> next_event 1)
		(defaults)
		(new_dialog "setup" dcl_id)
		(set_tile "scale" (itoa scale))
		(set_tile "vt" (itoa vt))

		(action_tile "scale" "(get_scale)")
		(action_tile "vt" "(get_vt)")
		(action_tile "accept" "(done_dialog 0)")
		(action_tile "cancel" "(done_dialog 1)")

		(setq next_event (start_dialog))
	)

	(unload_dialog dcl_id)
	(setvar "USERI1" scale)
	(princ)
)

; ***** INS V1.5 *****
; inserta una cadena dentro de otra cadena (ver insert de turbo pascal)
; si se trata de insertar en la posicion 0, regresa la cadena sin modificar
(defun ins (src tgt inx)
	(if (/= inx 0)
		(strcat (substr tgt 1 (1- inx)) src (substr tgt inx))
		(eval tgt)
	)
)

; ***** MM V1.5 *****
; regresa num milimetros segun la escala actual
(defun mm (num)
	(* num (/ scale 1000.0))
)

; ***** NODO V2.0 *****
; rutina primitiva para insertar nodos
(defun nodo (vx vy vz desc / hdle)
	(savemodes)
	(command "._layer" "m" "VT" "")
	(command "._insert" "VT"
		(strcat (rtos vx) "," (rtos vy) "," (rtos vz))
		(mm 1) "" "" (comasnz vz) (itoa vt) desc
	)

	(if nodolist
		(setq
			hdle (cdr (assoc 5 (entget (entlast))))
			nodolist (cons (cons (itoa vt) hdle) nodolist)
		)
	)

	(setq vt (1+ vt))
	(recallmodes)
	(princ)
)

; ***** NodoDrag V1.5 *****
; funcion para insertar nodos graficamente
(defun c:NodoDrag (/ vx vy vz desc vttemp pnt)
	(setq vttemp (getint (strcat "\nNumero de Vertice <" (itoa vt) "> :")))

	(setq pnt (getpoint "\nNodo : "))
	(setq vx (car pnt))
	(setq vy (cadr pnt))
	(setq vz (caddr pnt))
	(setq vz (getreal "\nAltura (Z) : "))
	(setq desc (getstring "Descripccion : "))

	(if (not vz)
		(setq vz 0.0)
	)

	(if vttemp
		(setq vt vttemp)
	)

	(if (not desc)
		(setq desc "---")
	)

	(nodo vx vy vz desc)
)

; ***** NodoFile n,x,y,z,d V1.5 *****
; Rutina para insertar nodos a partir de un archivo.
(defun c:nodofilenxyzd (/ arch linea vx vy vz desc)
	(setq arch (getfiled "Seleccione un archivo de coordenadas:" "" "XYZ;*" 0))
	(setq arch (open arch "r"))
	(while (setq linea (read-line arch))
		(setq vt (atoi linea))
		(setq linea (substr linea (1+ (pos "," linea))))
		(setq vx (atof linea))
		(setq linea (substr linea (1+ (pos "," linea))))
		(setq vy (atof linea))
		(setq linea (substr linea (1+ (pos "," linea))))
		(setq vz (atof linea))
		(setq linea (substr linea (1+ (pos "," linea))))
		(setq desc linea)

		(princ (strcat "\n" (itoa vt) "," (rtos vx) "," (rtos vy) "," (rtos vz) "," desc))
		(nodo vx vy vz desc)
	)
	(close arch)
	(princ)
)

; ***** NodoFile n,y,x,z,d V1.5 *****
; Rutina para insertar nodos a partir de un archivo.
(defun c:puntos (/ arch linea vx vy vz desc)
	(setq arch (getfiled "Seleccione un archivo de coordenadas:" "" "TXT;*" 0))
	(setq arch (open arch "r"))
	(while (setq linea (read-line arch))
		(if (= (pos "Linea" linea) 1)
			(progn
				(setq linea (substr linea (1+ (pos "," linea))))
				(setq vx (itoa (atoi linea)))
				(setq linea (substr linea (1+ (pos "," linea))))
				(setq vy (itoa (atoi linea)))
				(command "._line" (vt1 vx 1 nil) (vt1 vy 1 nil) "")
			)
			(progn
				(setq vt (atoi linea))
				(setq linea (substr linea (1+ (pos "," linea))))
				(setq vy (atof linea))
				(setq linea (substr linea (1+ (pos "," linea))))
				(setq vx (atof linea))
				(setq linea (substr linea (1+ (pos "," linea))))
				(setq vz (atof linea))
				(setq linea (substr linea (1+ (pos "," linea))))
				(setq desc linea)
		
				(princ (strcat "\n" (itoa vt) "," (rtos vx) "," (rtos vy) "," (rtos vz) "," desc))
				(nodo vx vy vz desc)
			)
		)
	)
	(close arch)
	(command "._zoom" "e")
	(princ)
)

; ***** NodoNEZ V1.5 *****
; funcion para insertar nodos tecleando las coordenadas Norte, Este, Altura
(defun c:NodoNEZ (/ vx vy vz desc vttemp)
	(setq vttemp (getint (strcat "\nNumero de Vertice <" (itoa vt) "> :")))

	(while (not (setq vy (getreal "\nCoordenada NORTE (Y) : "))))
	(while (not (setq vx (getreal "\nCoordenada ESTE (X) : "))))
	(setq vz (getreal "\nAltura (Z) : "))
	(setq desc (getstring "Descripccion : "))

	(if vttemp
		(setq vt vttemp)
	)

	(if (not vz)
		(setq vz 0.0)
	)

	(if (not desc)
		(setq desc "---")
	)

	(nodo vx vy vz desc)
)

; ***** NOZ V1.0 *****
; devuelve la coordenada que entra con z=0.0
(defun noz (xyz)
	(if xyz
		(list (car xyz) (cadr xyz) 0.0)
		nil
	)
)

; ***** POS V1.5 *****
; busca una cadena dentro de otra (ver Pos de turbo pascal)
; si la encuentra regresa la posicion en la que se encontro,
; si no la encuentra regresa un cero.
(defun pos (subcad cad / cnt)
	(setq cnt 1)
	(while
		(and (/= subcad (substr cad cnt (strlen subcad)))
			(< cnt (strlen cad))
		)
		(setq cnt (1+ cnt))
	)
	(if (= subcad (substr cad cnt (strlen subcad)))
		(eval cnt)
		(eval 0)
	)
)

; ***** RECALLMODES *****
(defun recallmodes ()
	(setvar "cmdecho" cmdecho)
	(setvar "orthomode" orthomode)
	(setvar "osmode" osmode)
	(setvar "snapmode" snapmode)
)

; ***** RENUMERA NODOS V1.0 *****
; Renumera los nodos a partir de un numero inicial y con un incremento dado.
(defun c:renum (/ ini inc hdle)
	(setq
		ini (getint "\nNumero inicial : ")
		inc (getint "\nIncremento : ")
		nodolist nil
	)
	(vt1 "1" 1 nil)

	(princ "\n")

	(while (<= minvt maxvt)
		(setq hdle (cdr (assoc (itoa minvt) nodolist)))

		(if hdle
			(progn
				(setq hdle (handent hdle)) ;<Entity name : xxxxx>
				(if hdle
					(progn
						(setq hdle (entget (entnext (entnext hdle)))
							hdle (subst (cons 1 (itoa ini)) (assoc 1 hdle) hdle)
						)
						(entmod hdle)
						(entupd (cdr (assoc -1 hdle)))
						(setq ini (+ ini inc))
						(princ (strcat "\rAsignando el vertice No. " (itoa ini)))
					)
				)
			)
		)

		(setq minvt (1+ minvt))
	)
	(setq nodolist nil)
	(vt1 "1" 1 nil)
	(princ)
)

; ***** REPORTE V1.5 *****
; Genera una tabla con el listado de las coordenadas de cada vertice y
; da la opcion de generar un archivo con esa lista.
(defun c:reporte (/ delvt alvt tbl tblx tbly xyz vx vy vx)
	(setq nodolist nil) ; nodolist=nil ==> (eval vt1.initlist)
	(vt1 "1" 1 nil)

	(setq
		delvt (getint "\nCrear reporte de coordenadas del vertice # ")
		alvt (getint "\nal vertice # ")
		tbl (getpoint "\nEsquina superior izquierda del reporte :")
		tblx (car tbl)
		tbly (cadr tbl)
		arch (getstring "\nNombre del archivo para grabar el reporte ([ENTER]=No graba datos) :")
	)
	(if arch
		(setq arch (open arch "w"))
	)

	(command "._layer" "m" "cuadro" "")

	(while (<= delvt alvt)
		(setq xyz (vt1 (itoa delvt) nil nil))
		(if xyz
			(progn
				(setq
					vx (car xyz)
					vy (cadr xyz)
					vz (caddr xyz)
				)
				(command "._insert" "entrada"
					(strcat (rtos tblx) "," (rtos tbly))
					(mm 1) "" "" ""
					(itoa delvt) (comas vx) (comas vy) (comasnz vz)
				)
				(setq tbly (- tbly (mm 3.5)))

				(if arch
					(princ (strcat
						(itoa delvt)  ","
						(rtos vy 2 3) ","
						(rtos vx 2 3) ","
						(rtos vz 2 3) ",."
						"\n") arch
					)
				)
			)
		)
		(setq delvt (1+ delvt))
	)
	(if arch
		(close arch)
	)
)

; ***** ROTESC1 & ROTESC V1.2 *****
; Rota y escala los nodos (bloques VT) de forma que esten horizontales y
; que tengan 1 mm segun la escala actual.
(defun rotesc1 (ent / vtxyz scref)
	(command "._change" ent "" "" "" 0.0)   ;rotacion = 0.0

	(setq vtxyz (cdr (assoc 10 (entget ent))))
	(setq scref (cdr (assoc 41 (entget ent))))
	(command "._scale" ent "" vtxyz "R" scref (mm 1))
)

(defun c:rotesc (/ conj cont contup ent)
	(setq conj (ssget '((2 . "VT"))))
	(setq cont (sslength conj))
	(setq contup 0)

	(while (/= cont 0)
		(setq ent (ssname conj (1- cont)))
		(rotesc1 ent)
		(setq contup (1+ contup))
		(setq cont (1- cont))

		(princ (strcat (itoa contup) " vertices actualizados.\r"))
	)
	(princ)
)

; ***** SAVEMODES *****
(defun savemodes ()
	(setq
		cmdecho (getvar "cmdecho")
		orthomode (getvar "orthomode")
		osmode (getvar "osmode")
		snapmode (getvar "snapmode")
	)
	(setvar "cmdecho" 0)
	(setvar "orthomode" 0)
	(setvar "osmode" 0)
	(setvar "snapmode" 0)
)

; ***** SNODE (SNAP NODE) V1.0 *****
; Inserta un nodo en los vertices de objetos seleccionados
(defun c:snode (/ conj cont ent etype xyz)
	(setq conj (ssget)
		cont (sslength conj)
	)

	(princ "\n")
	(while (/= cont 0)
		(setq ent (ssname conj (1- cont))
			etype (cdr (assoc 0 (entget ent)))
		)
		(cond
			((= etype "POINT")
				(setq xyz (assoc 10 (entget ent)))
				(nodo (cadr xyz) (caddr xyz) (cadddr xyz) " ")
			)
			((= etype "LINE")
				(setq xyz (assoc 10 (entget ent)))
				(nodo (cadr xyz) (caddr xyz) (cadddr xyz) " ")
				(setq xyz (assoc 11 (entget ent)))
				(nodo (cadr xyz) (caddr xyz) (cadddr xyz) " ")
			)
			((= etype "POLYLINE")
				(setq ent (entnext ent))
				(while (= (cdr (assoc 0 (entget ent))) "VERTEX")
					(setq xyz (assoc 10 (entget ent)))
					(nodo (cadr xyz) (caddr xyz) (cadddr xyz) " ")
					(setq ent (entnext ent))
				)
			)
		)
		(setq cont (1- cont))
		(princ (strcat "Faltan " (itoa cont) " entidades por procesar.\r"))
	)
	(princ)
)

; ***** VT1 & VTGEN & VT2D & VT3D & VTSEL V2.9 *****
; retorna las coordenadas de un vertice para usar de forma transparente en
; lineas y polilineas, una sola coordenada (#nn) o una serie (#nn-mm)
; VT2D regresa *solo* la coordenada (x,y)
; VT3D regresa las tres coordenadas (x,y,z)
; VTSEL regresa la entidad para poder ser copiada, movida, etc.
(defun vt1 (vtaux zd xy_or_e / hdle)

	(defun initlist (/ conjcdo cont aux hdle vtnum)
				;cuentavt minvt maxvt
		(princ "\nActualizando lista de datos .....")

		(setq cuentavt 0 minvt 9999 maxvt 0)
		(setq nodolist (list (cons "0" "0")))
		(setq conjcdo (ssget "X" '((2 . "VT"))))
		(if conjcdo
			(progn
				(setq cont (sslength conjcdo))

				(while (/= cont 0)
					(setq
						aux (ssname conjcdo (1- cont))
						hdle (cdr (assoc 5 (entget aux)))
						vtnum (cdr (assoc 1 (entget (entnext (entnext aux)))))
						nodolist (cons (cons vtnum hdle) nodolist)
						cuentavt (1+ cuentavt)
						minvt (min minvt (atoi vtnum))
						maxvt (max maxvt (atoi vtnum))
						cont (1- cont)
					)
				)
				(princ "\nLista de datos actualizada.")
				(princ (strcat "\nNumero de vertices : " (itoa cuentavt)
							"    Vt min : " (itoa minvt)
							"    Vt max : " (itoa maxvt))
				)
			)
		)
	)

	(if (not nodolist)
		(initlist)
	)

	(setq hdle (cdr (assoc vtaux nodolist)))

	(if hdle
		(progn
			(setq hdle (handent hdle)) ;<Entity name : xxxxx>
			(if (and hdle (not xy_or_e))
				(progn
					(setq hdle (cdr (assoc 10 (entget hdle)))) ;(x,y,z)
					(if zd
						(setq hdle (noz hdle)) ;(x,y,0.0)
					)
				)
			)
		)
	)

	(if (and (not hdle) (/= vtaux "1"))
		(princ (strcat "\nNo existe el vertice " vtaux))
	)

	(eval 'hdle)
)

(defun vtgen (zd xy_or_e / vtnum xyz ini fin)
	(setvar "CMDECHO" 1)
	(setq vtnum (getstring "#"))
	(while (/= vtnum "")
		(if (= (pos "-" vtnum) 0)
			(progn
				(setq xyz (vt1 vtnum zd xy_or_e))
				(princ xyz)
				(if xyz
					(command xyz)
					(command vtnum)
				)
			)
			(progn
				(setq ini (atoi (substr vtnum 1 (1- (pos "-" vtnum)))))
				(setq fin (atoi (substr vtnum   (1+ (pos "-" vtnum)))))
				(if (< ini fin)
					(while (<= ini fin)
						(setq xyz (vt1 (itoa ini) zd xy_or_e))
						(princ xyz)
						(if xyz
							(command xyz)
						)
						(setq ini (1+ ini))
					)
					(while (>= ini fin)
						(setq xyz (vt1 (itoa ini) zd xy_or_e))
						(princ xyz)
						(if xyz
							(command xyz)
						)
						(setq ini (1- ini))
					)
				)
			)
		)
		(setq vtnum (getstring "#"))
	)
	(setvar "CMDECHO" 0)
	(princ)
)

(defun c:vt2d ()
	(vtgen 1 nil)
)

(defun c:vt3d ()
	(vtgen nil nil)
)

(defun c:vtsel ()
	(vtgen 1 1)
)

; ***** ZVT V1.0 *****
; Zoom con el vertice seleccionado al centro de la pantalla.
(defun c:zvt (/ xyz pt1 pt2)
	(setq xyz (vt1 (getstring "\nNumero de vertice: #") 1 nil))
	(if xyz
		(progn
			(command "._zoom" "c" xyz (mm 100))
			(setq pt1 (list (- (car xyz) 40) (- (cadr xyz) 40)))
			(setq pt2 (list (+ (car xyz) 40) (+ (cadr xyz) 40)))
			(grdraw pt1 pt2 2 1)
			(setq pt1 (list (- (car xyz) 40) (+ (cadr xyz) 40)))
			(setq pt2 (list (+ (car xyz) 40) (- (cadr xyz) 40)))
			(grdraw pt1 pt2 2 1)
		)
	)
	(princ)
)

;****************************************************************************
(princ "\nRutinas GEOTOP V1.2 cargadas\n")
(c:ddsetup)
(princ)
